#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SeniorDivideJackpotCFG.h"
std::auto_ptr<Fish_SeniorDivideJackpotCFG> Fish_SeniorDivideJackpotCFG::msSingleton(nullptr);

int Fish_SeniorDivideJackpotCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorDivideJackpotCFGData* Fish_SeniorDivideJackpotCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SeniorDivideJackpotCFGData>& Fish_SeniorDivideJackpotCFG::GetMapData()
{
	return mMapData;
}

void Fish_SeniorDivideJackpotCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SeniorDivideJackpotCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorDivideJackpotCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mWeight = element->IntAttribute("Weight");
		data.mDivideJackpotMin = element->IntAttribute("DivideJackpotMin");
		data.mDivideJackpotMax = element->IntAttribute("DivideJackpotMax");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SeniorDivideJackpotCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorDivideJackpotCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SeniorDivideJackpotCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SeniorDivideJackpotCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SeniorDivideJackpotCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "DivideJackpotMin", data.mDivideJackpotMin);
		LuaCfgHelper::readInt(L, "DivideJackpotMax", data.mDivideJackpotMax);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SeniorDivideJackpotCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorDivideJackpotCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SeniorDivideJackpotCFG* Fish_SeniorDivideJackpotCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorDivideJackpotCFG());
	}
	return msSingleton.get();
}

void Fish_SeniorDivideJackpotCFG::Release()
{
	msSingleton.reset(nullptr);
}
